{###############################################################################
# Dipesh-TxtEdit-32 Version 1.xx.xx                         Delphi 3 Quellcode #
################################################################################
# Programmiert & Entwickelt von Sebastian Sauer (Dipesh)                       #
# E-Mail: dipesh@gmx.de                                                        #
# Homepage: http://members.tripod.de/dipesh4                                   #
################################################################################
# STATISTK.PAS - TStatistikForm                                                #
###############################################################################}

UNIT Statistk;

INTERFACE

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

Type
  TStatistikForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label_Zeilenanzahl: TLabel;
    Label_Wortanzahl: TLabel;
    Label_Zeichenanzahl: TLabel;
    Label4: TLabel;
    Label_Dateiname: TLabel;
    Label5: TLabel;
    Label_ZuletztGespeichert: TLabel;
    Label7: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label_DateiGroesse: TLabel;
    Label_DateiAttribute: TLabel;
    Label_Erstellungszeit: TLabel;
    Label9: TLabel;
    Label_AnzahlLeerzeichen: TLabel;
    Label10: TLabel;
    Label_LetzterZugriff: TLabel;
    Button_Ok: TButton;
    procedure OnCreate(Sender: TObject);
    procedure OnActivate(Sender: TObject);
  end;

Var
  StatistikForm: TStatistikForm;

IMPLEMENTATION

Uses Globals, Main, MainCld;

{$R *.DFM}

procedure TStatistikForm.OnCreate(Sender: TObject);
begin Screen.Cursor:=crHourGlass; end;

procedure TStatistikForm.OnActivate(Sender: TObject);
var OA_Bool1: boolean; OA_Int1, OA_Int2, OA_Int3: integer; OA_Ext1, OA_Ext2, OA_Ext3: extended; OA_Str1, OA_Str2: string; OA_TSR: TSearchRec; OA_SysTime: TSystemTime;
  function ConvertSysTimeToStr(ConvertSysTime: TSystemTime): string;
  begin
    Result:=IntToStr(ConvertSysTime.wDay)+'.'+IntToStr(ConvertSysTime.wMonth)+'.'+IntToStr(ConvertSysTime.wYear)+' '+
            IntToStr(ConvertSysTime.wHour)+':'+IntToStr(ConvertSysTime.wMinute)+':'+IntToStr(ConvertSysTime.wSecond);
  end;
begin
  OA_Str1:=MainForm.ActiveMDIChild.Caption;
  If FindFirst(OA_Str1,faAnyFile,OA_TSR)=0 then begin
    Label_DateiGroesse.Caption:=FormatInteger(OA_TSR.Size)+' Bytes.';
    OA_Str2:='';
    If (OA_TSR.Attr and faHidden > 0) then OA_Str2:='Versteckt '; If (OA_TSR.Attr and faReadOnly > 0) then OA_Str2:=OA_Str2+'Schreibgeschtzt ';
    If (OA_TSR.Attr and faSysFile > 0) then OA_Str2:=OA_Str2+'Systemdatei '; If (OA_TSR.Attr and faArchive > 0) then OA_Str2:=OA_Str2+'Archivdatei ';
    Label_DateiAttribute.Caption:=OA_Str2;
    FileTimeToSystemTime(OA_TSR.FindData.ftCreationTime,OA_SysTime); Label_Erstellungszeit.Caption:=ConvertSysTimeToStr(OA_SysTime);
    FileTimeToSystemTime(OA_TSR.FindData.ftLastWriteTime,OA_SysTime); Label_ZuletztGespeichert.Caption:=ConvertSysTimeToStr(OA_SysTime);
    FileTimeToSystemTime(OA_TSR.FindData.ftLastAccessTime,OA_SysTime); Label_LetzterZugriff.Caption:=ConvertSysTimeToStr(OA_SysTime);
  end else OA_Str1:='Ungespeichert, keine zugehrige Textdatei vorhanden...';
  Label_Dateiname.Caption:=OA_Str1;
  FindClose(OA_TSR);
  Update;
  OA_Int1:=TMainChildForm(MainForm.ActiveMDIChild).RichEdit.Lines.Count;
  Label_Zeilenanzahl.Caption:=FormatInteger(OA_Int1);
  OA_Ext1:=0; OA_Ext2:=0; OA_Ext3:=0; OA_Bool1:=true;
  For OA_Int2:=0 to OA_Int1-1 do begin
    OA_Str1:=TMainChildForm(MainForm.ActiveMDIChild).RichEdit.Lines[OA_Int2];
    OA_Ext3:=OA_Ext3+Length(OA_Str1);
    For OA_Int3:=1 to Length(OA_Str1) do begin
      If OA_Str1[OA_Int3]=' ' then begin OA_Ext2:=OA_Ext2+1; OA_Bool1:=true; end
      else begin If OA_Bool1 then begin OA_Ext1:=OA_Ext1+1; OA_Bool1:=false; end; end;
    end;
  end;
  Label_Wortanzahl.Caption:=FormatFloat('#,###,###,###,###,###,###,##0',OA_Ext1);
  Label_AnzahlLeerzeichen.Caption:=FormatFloat('#,###,###,###,###,###,###,##0',OA_Ext2);
  Label_Zeichenanzahl.Caption:=FormatFloat('#,###,###,###,###,###,###,##0',OA_Ext3);
  Update;
  Screen.Cursor:=crDefault;
end;

END.
