{###############################################################################
# Dipesh-TxtEdit-32 Version 1.xx.xx                         Delphi 3 Quellcode #
################################################################################
# Programmiert & Entwickelt von Sebastian Sauer (Dipesh)                       #
# E-Mail: dipesh@gmx.de                                                        #
# Homepage: http://members.tripod.de/dipesh4                                   #
################################################################################
# MAIN.PAS - TMainForm                                                         #
###############################################################################}

{
ERWEITERUNGSIDEEN:

- Html-Sonderzeichen ersetzen -  zu &ue... und so weiter
- in einstellungenform:
  - "Anschlieende Leerzeichen beim speichern entfernen"
  - "Tabulatoren" beim Speichern durch Leerzeichen ersetzen"
- MenuItem "Alles speichern" hinzufgen
- MenuItem "Senden an..." -> Windows Standard E-Mail Programm mit Inhalt von aktueller Textdatei aufrufen
           "Dateikontext..."
- MenuItem "Erneut ffnen..."
- MenuItem "Einfgen..." -> "Datei anhngen"
}

UNIT Main;

INTERFACE

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, IniFiles, Globals,
  TB97, TB97Ctls, TB97Tlbr, ComCtrls, ExtCtrls;

Type
  TMainForm = class(TForm)
    DockTop: TDock97;
    DockBottom: TDock97;
    DockLeft: TDock97;
    DockRight: TDock97;
    Toolbar_Datei: TToolbar97;
    MainMenu: TMainMenu;
    MainMenu_Datei: TMenuItem;
    MainMenu_Datei_Neu: TMenuItem;
    MainMenu_Datei_Oeffnen: TMenuItem;
    N1: TMenuItem;
    MainMenu_Datei_Beenden: TMenuItem;
    MainMenu_Fenster: TMenuItem;
    MainMenu_Fenster_Vorheriges: TMenuItem;
    MainMenu_Fenster_Naechstes: TMenuItem;
    N3: TMenuItem;
    MainMenu_Fenster_Laengsteilen: TMenuItem;
    MainMenu_Fenster_Ueberlappen: TMenuItem;
    MainMenu_Fenster_SymboleAnordnen: TMenuItem;
    MainMenu_Hilfe: TMenuItem;
    MainMenu_Hilfe_Hilfethemen: TMenuItem;
    N4: TMenuItem;
    MainMenu_Hilfe_Infos: TMenuItem;
    MainMenu_Optionen: TMenuItem;
    OpenDialog: TOpenDialog;
    MainMenu_Tools: TMenuItem;
    Button_Drucken: TToolbarButton97;
    Button_Neu: TToolbarButton97;
    Button_Speichern: TToolbarButton97;
    Button_Oeffnen: TToolbarButton97;
    MainMenu_Optionen_EinstellungenKonfigurieren: TMenuItem;
    Toolbar_Bearbeiten: TToolbar97;
    Button_Wiederherstellen: TToolbarButton97;
    Toolbar_Markierung: TToolbar97;
    Button_AllesMarkieren: TToolbarButton97;
    Button_Rueckgaengig: TToolbarButton97;
    ToolbarSep971: TToolbarSep97;
    Button_Ausschneiden: TToolbarButton97;
    Button_Loeschen: TToolbarButton97;
    Button_Einfuegen: TToolbarButton97;
    Button_Kopieren: TToolbarButton97;
    Button_Grossbuchstaben: TToolbarButton97;
    Button_Kleinbuchstaben: TToolbarButton97;
    Button_NichtsMarkieren: TToolbarButton97;
    Toolbar_Suchen: TToolbar97;
    Toolbar_Optionen: TToolbar97;
    Button_Suchen: TToolbarButton97;
    Button_EinstellungenKonfigurieren: TToolbarButton97;
    ToolbarSep972: TToolbarSep97;
    ToolbarSep973: TToolbarSep97;
    Button_Infos: TToolbarButton97;
    ToolbarSep975: TToolbarSep97;
    N2: TMenuItem;
    MainMenu_Optionen_ToolbarDateiEinblenden: TMenuItem;
    MainMenu_Optionen_ToolbarBearbeitenEinblenden: TMenuItem;
    MainMenu_Optionen_ToolbarMarkierungEinblenden: TMenuItem;
    MainMenu_Optionen_ToolbarSuchenEinblenden: TMenuItem;
    MainMenu_Optionen_ToolbarOptionenEinblenden: TMenuItem;
    Button_Weitersuchen: TToolbarButton97;
    Toolbar_Fenster: TToolbar97;
    Button_Laengsteilen: TToolbarButton97;
    Button_Ueberlappen: TToolbarButton97;
    PagePanel: TPanel;
    PageCtrl: TPageControl;
    MainMenu_Fenster_Querteilen: TMenuItem;
    MainMenu_Optionen_ToolbarFensterEinblenden: TMenuItem;
    Button_Querteilen: TToolbarButton97;
    SaveDialog: TSaveDialog;
    // Formular
    procedure OnClose(Sender: TObject; var Action: TCloseAction);
    procedure OnCreate(Sender: TObject);
    procedure OnActivate(Sender: TObject);
    // MainMenu
    procedure MainMenu_Datei_Neu_OnClick(Sender: TObject);
    procedure MainMenu_Datei_Oeffnen_OnClick(Sender: TObject);
    procedure MainMenu_Datei_Beenden_OnClick(Sender: TObject);
    procedure MainMenu_Optionen_ToolbarDateiEinblenden_OnClick(Sender: TObject);
    procedure MainMenu_Optionen_ToolbarBearbeitenEinblenden_OnClick(Sender: TObject);
    procedure MainMenu_Optionen_ToolbarMarkierungEinblenden_OnClick(Sender: TObject);
    procedure MainMenu_Optionen_ToolbarSuchenEinblenden_OnClick(Sender: TObject);
    procedure MainMenu_Optionen_ToolbarOptionenEinblenden_OnClick(Sender: TObject);
    procedure MainMenu_Optionen_ToolbarFensterEinblenden_OnClick(Sender: TObject);
    procedure MainMenu_Optionen_EinstellungenKonfigurieren_OnClick(Sender: TObject);
    procedure MainMenu_Fenster_Vorheriges_OnClick(Sender: TObject);
    procedure MainMenu_Fenster_Naechstes_OnClick(Sender: TObject);
    procedure MainMenu_Fenster_Laengsteilen_OnClick(Sender: TObject);
    procedure MainMenu_Fenster_Ueberlappen_OnClick(Sender: TObject);
    procedure MainMenu_Fenster_SymboleAnordnen_OnClick(Sender: TObject);
    procedure MainMenu_Tools_OnClick(Sender: TObject);
    procedure MainMenu_Hilfe_Hilfethemen_OnClick(Sender: TObject);
    procedure MainMenu_Hilfe_Infos_OnClick(Sender: TObject);
    // Toolbars
    procedure Button_Speichern_OnClick(Sender: TObject);
    procedure Button_Drucken_OnClick(Sender: TObject);
    procedure Button_Rueckgaengig_OnClick(Sender: TObject);
    procedure Button_Wiederherstellen_OnClick(Sender: TObject);
    procedure Button_Ausschneiden_OnClick(Sender: TObject);
    procedure Button_Kopieren_OnClick(Sender: TObject);
    procedure Button_Einfuegen_OnClick(Sender: TObject);
    procedure Button_Loeschen_OnClick(Sender: TObject);
    procedure Button_Grossbuchstaben_OnClick(Sender: TObject);
    procedure Button_Kleinbuchstaben_OnClick(Sender: TObject);
    procedure Button_NichtsMarkieren_OnClick(Sender: TObject);
    procedure Button_AllesMarkieren_OnClick(Sender: TObject);
    procedure Button_Suchen_OnClick(Sender: TObject);
    procedure Button_Weitersuchen_OnClick(Sender: TObject);
    procedure PageCtrlChange(Sender: TObject);
    procedure MainMenu_Fenster_Querteilen_OnClick(Sender: TObject);
  public
    // Public-Deklarationen
    ChildNr: integer;
    function AndereDSM32InstanzAktivieren: boolean;
    procedure OpenTextFile(TextFileStr: string);
    procedure AddItemToToolsMenu(CaptionStr, HintStr: string);
  end;

Var
  StrList: TStringList;
  MainForm: TMainForm;

IMPLEMENTATION

Uses MainCld, Einstell, Infos;

{$R *.DFM}

{-------------------------------------------------------------------------------
Formular
-------------------------------------------------------------------------------}

procedure TMainForm.OnClose(Sender: TObject; var Action: TCloseAction);
var OC_Int1: integer; OC_IniFile: TIniFile;
begin                                                 
  // Ini-Datei schreiben
  If (SaveSettingsOnExit)or(LoadSaveOpenFiles) then begin
    Try OC_IniFile:=TIniFile.Create(IniFileCom);
      If SaveSettingsOnExit then begin
        // -> [MainWindow]        
        If WindowState=wsNormal then begin
          If Window_Width<>Width then OC_IniFile.WriteInteger('MainWindow','Width',Width);
          If Window_Height<>Height then OC_IniFile.WriteInteger('MainWindow','Height',Height);
        end;
        If Window_State<>WindowState then begin Case WindowState of wsMaximized: OC_Int1:=2; wsMinimized: OC_Int1:=3; else OC_Int1:=1; end;
          OC_IniFile.WriteInteger('MainWindow','State',OC_Int1); end;
      end;
      If LoadSaveOpenFiles then begin
        // -> [OpenFiles]
        OC_IniFile.EraseSection('OpenFiles');
        For OC_Int1:=0 to MDIChildCount-1 do If FileExists(MDIChildren[OC_Int1].Caption) then
          OC_IniFile.WriteString('OpenFiles',IntToStr(OC_Int1+1),MDIChildren[OC_Int1].Caption);
      end;
    Finally OC_IniFile.Free; end;
    If SaveSettingsOnExit then IniSaveToolbarPositions(MainForm,IniFileCom); // Positionen der Toolbars in Ini-Datei schreiben
  end;
end;

procedure TMainForm.OnCreate(Sender: TObject);
var OC_Int1: integer; OC_Str1, OC_Str2: string; OC_StrLst1: Tstringlist; OC_IniFile: TIniFile;
begin
  Screen.Cursor:=crHourGlass; 
  // Ini-Datei suchen
  If FileExists(IniFileCom) then IniFileCom:=ExpandFileName(IniFileCom) else
  If FileExists(ExtractFilePath(ParamStr(0))+IniFileCom) then IniFileCom:=ExtractFilePath(ParamStr(0))+IniFileCom else
  If MessageBox(0,PChar('Die Ini-Datei "'+IniFileCom+'" konnte nicht gefunden werden.'+#13+'Trotzdem fortsetzen ?'),'Fehler:',MB_IconQuestion+MB_OkCancel+MB_SetForeground+MB_ApplModal)<>idOk then Try Free; Finally Halt; end;
  // Ini-Datei lesen
  StrList:=TStringList.Create;
  If FileExists(IniFileCom) then Try OC_IniFile:=TIniFile.Create(IniFileCom);
    // -> [MainWindow]
    SingleInstance:=OC_IniFile.ReadBool('MainWindow','SingleInstance',SingleInstance);
    Window_Width:=OC_IniFile.ReadInteger('MainWindow','Width',-1);
    If Window_Width>0 then Width:=Window_Width;
    Window_Height:=OC_IniFile.ReadInteger('MainWindow','Height',-1);
    If Window_Height>0 then Height:=Window_Height;
    Case OC_IniFile.ReadInteger('MainWindow','State',-1) of
     1: Window_State:=wsNormal;
     2: Window_State:=wsMaximized;
     3: Window_State:=wsMinimized;
    end;
    // -> [OpenFiles]
    If LoadSaveOpenFiles then OC_IniFile.ReadSectionValues('OpenFiles',StrList);
    // -> [Tools]
    OC_StrLst1:=TStringList.Create; OC_IniFile.ReadSectionValues('Tools',OC_StrLst1);
    For OC_Int1:=0 to OC_StrLst1.Count-1 do begin
      OC_Str1:=copy(OC_StrLst1[OC_Int1],1,Pos('=',OC_StrLst1[OC_Int1])-1);
      OC_Str2:=copy(OC_StrLst1[OC_Int1],Length(OC_Str1)+2,Length(OC_StrLst1[OC_Int1])-Length(OC_Str1)+2);
      AddItemToToolsMenu(OC_Str1,OC_Str2);
    end;
    OC_StrLst1.Free;
    // -> [View]
    ShowMarkLeiste:=OC_IniFile.ReadBool('View','ShowMarkbar',ShowMarkLeiste);
    UseAutoUrls:=OC_IniFile.ReadBool('View','AutoUrlDetection',UseAutoUrls);
    StartWithNewDoc:=OC_IniFile.ReadBool('View','StartWithNewDoc',StartWithNewDoc);
    IfReadOnlyThenNurLesenZulassen:=OC_IniFile.ReadBool('View','OpenAsReadOnlyIfIsReadOnly',IfReadOnlyThenNurLesenZulassen);
    // -> [Open]
    OpenDialog.Filter:=OC_IniFile.ReadString('Open','Filter',OpenDialog.Filter);
    // -> [Save]
    SaveDialog.Filter:=OC_IniFile.ReadString('Save','Filter',SaveDialog.Filter);
    SaveSettingsOnExit:=OC_IniFile.ReadBool('Save','AutoSaveSettings',SaveSettingsOnExit);
    LoadSaveOpenFiles:=OC_IniFile.ReadBool('Save','AutoSaveOpenFiles',LoadSaveOpenFiles);
  Finally OC_IniFile.Free; end;
  If SingleInstance then If AndereDSM32InstanzAktivieren then Try Free; Finally Halt; end;
  IniLoadToolbarPositions(MainForm,IniFileCom); // Positionen der Toolbars aus Ini-Datei lesen und entspr. setzen
  MainMenu_Optionen_ToolbarDateiEinblenden.Checked:=Toolbar_Datei.Visible; MainMenu_Optionen_ToolbarBearbeitenEinblenden.Checked:=Toolbar_Bearbeiten.Visible;
  MainMenu_Optionen_ToolbarMarkierungEinblenden.Checked:=Toolbar_Markierung.Visible; MainMenu_Optionen_ToolbarSuchenEinblenden.Checked:=Toolbar_Suchen.Visible;
  MainMenu_Optionen_ToolbarOptionenEinblenden.Checked:=Toolbar_Optionen.Visible;
  MainMenu_Optionen_ToolbarFensterEinblenden.Checked:=Toolbar_Fenster.Visible;
end;

procedure TMainForm.OnActivate(Sender: TObject);
var OA_Int1: integer; OA_Str1: string;
begin
  If not IsFirstOnActivate then Exit; WindowState:=Window_State; IsFirstOnActivate:=false; Update;
  Try
    If LoadSaveOpenFiles then If StrList.Count>0 then // Alten Zustand wiederherstellen
      For OA_Int1:=0 to StrList.Count-1 do begin
        OA_Str1:=copy(StrList[OA_Int1],Pos('=',StrList[OA_Int1])+1,Length(StrList[OA_Int1])-Pos('=',StrList[OA_Int1]));
        If FileExists(OA_Str1) then OpenTextFile(ExpandFileName(OA_Str1));
      end;
    StrList.Free; OA_Str1:='';
    For OA_Int1:=1 to ParamCount do begin // Kommandozeilenparameter auswerten
      If FileExists(ParamStr(OA_Int1)) then OpenTextFile(ExpandFileName(ParamStr(OA_Int1))) else
      If FileExists(OA_Str1+ParamStr(OA_Int1)) then begin OpenTextFile(ExpandFileName(OA_Str1+ParamStr(OA_Int1))); OA_Str1:=''; end else
      If FileExists(OA_Str1+' '+ParamStr(OA_Int1)) then begin OpenTextFile(ExpandFileName(OA_Str1+' '+ParamStr(OA_Int1))); OA_Str1:=''; end else
      If FileExists(OA_Str1+'  '+ParamStr(OA_Int1)) then begin OpenTextFile(ExpandFileName(OA_Str1+'  '+ParamStr(OA_Int1))); OA_Str1:=''; end else
      OA_Str1:=Trim(OA_Str1+' '+ParamStr(OA_Int1));
    end;    
    If (StartWithNewDoc)and(MDIChildCount<1) then MainMenu_Datei_Neu_OnClick(Sender);
  Finally Screen.Cursor:=crDefault; end;
end;

{-------------------------------------------------------------------------------
MainMenu
-------------------------------------------------------------------------------}

procedure TMainForm.MainMenu_Datei_Neu_OnClick(Sender: TObject);
var s1: string;
begin
  With TMainChildForm.Create(Self) do begin s1:='<Unbenannt>'; Caption:=s1; StatusBar.SimplePanel:=false; inc(ChildNr); Tag:=ChildNr;  
    With TTabSheet.Create(MainForm.PageCtrl) do begin PageControl:=MainForm.PageCtrl; Name:='Tab'+inttostr(ChildNr);
      Caption:=s1; Tag:=ChildNr; MainForm.PageCtrl.ActivePage:=MainForm.PageCtrl.Pages[TabIndex]; end;
  end;
end;

procedure TMainForm.MainMenu_Datei_Oeffnen_OnClick(Sender: TObject);
var MDOOC_Str1: string;
begin
  With OpenDialog do begin
    If FileExists(ActiveMDIChild.Caption) then MDOOC_Str1:=ActiveMDIChild.Caption else MDOOC_Str1:=ExtractFilePath(ParamStr(0));  
    InitialDir:=ExtractFilePath(MDOOC_Str1); Filename:=ExtractFileName(MDOOC_Str1);
    If Execute then OpenTextFile(ExpandFileName(Filename));
  end;
end;

procedure TMainForm.MainMenu_Datei_Beenden_OnClick(Sender: TObject);
begin Close; end;

procedure TMainForm.MainMenu_Optionen_ToolbarDateiEinblenden_OnClick(Sender: TObject);
begin
  If Toolbar_Datei.Visible then begin Toolbar_Datei.Visible:=false; MainMenu_Optionen_ToolbarDateiEinblenden.Checked:=false; end
  else begin Toolbar_Datei.Visible:=true; MainMenu_Optionen_ToolbarDateiEinblenden.Checked:=true; end;
end;

procedure TMainForm.MainMenu_Optionen_ToolbarBearbeitenEinblenden_OnClick(Sender: TObject);
begin
  If Toolbar_Bearbeiten.Visible then begin Toolbar_Bearbeiten.Visible:=false; MainMenu_Optionen_ToolbarBearbeitenEinblenden.Checked:=false; end
  else begin Toolbar_Bearbeiten.Visible:=true; MainMenu_Optionen_ToolbarBearbeitenEinblenden.Checked:=true; end;
end;

procedure TMainForm.MainMenu_Optionen_ToolbarMarkierungEinblenden_OnClick(Sender: TObject);
begin
  If Toolbar_Markierung.Visible then begin Toolbar_Markierung.Visible:=false; MainMenu_Optionen_ToolbarMarkierungEinblenden.Checked:=false; end
  else begin Toolbar_Markierung.Visible:=true; MainMenu_Optionen_ToolbarMarkierungEinblenden.Checked:=true; end;
end;

procedure TMainForm.MainMenu_Optionen_ToolbarSuchenEinblenden_OnClick(Sender: TObject);
begin
  If Toolbar_Suchen.Visible then begin Toolbar_Suchen.Visible:=false; MainMenu_Optionen_ToolbarSuchenEinblenden.Checked:=false; end
  else begin Toolbar_Suchen.Visible:=true; MainMenu_Optionen_ToolbarSuchenEinblenden.Checked:=true; end;
end;

procedure TMainForm.MainMenu_Optionen_ToolbarOptionenEinblenden_OnClick(Sender: TObject);
begin
  If Toolbar_Optionen.Visible then begin Toolbar_Optionen.Visible:=false; MainMenu_Optionen_ToolbarOptionenEinblenden.Checked:=false; end
  else begin Toolbar_Optionen.Visible:=true; MainMenu_Optionen_ToolbarOptionenEinblenden.Checked:=true; end;
end;

procedure TMainForm.MainMenu_Optionen_ToolbarFensterEinblenden_OnClick(Sender: TObject);
begin
  If Toolbar_Fenster.Visible then begin Toolbar_Fenster.Visible:=false; MainMenu_Optionen_ToolbarFensterEinblenden.Checked:=false; end
  else begin Toolbar_Fenster.Visible:=true; MainMenu_Optionen_ToolbarFensterEinblenden.Checked:=true; end;
end;

procedure TMainForm.MainMenu_Optionen_EinstellungenKonfigurieren_OnClick(Sender: TObject);
begin With TEinstellungenForm.Create(Self) do Try ShowModal; Finally Free; end; end;

procedure TMainForm.MainMenu_Fenster_Vorheriges_OnClick(Sender: TObject);
begin Previous; end;

procedure TMainForm.MainMenu_Fenster_Naechstes_OnClick(Sender: TObject);
begin Next; end;

procedure TMainForm.MainMenu_Fenster_Laengsteilen_OnClick(Sender: TObject);
begin TileMode:=tbHorizontal; Tile; end;

procedure TMainForm.MainMenu_Fenster_Querteilen_OnClick(Sender: TObject);
begin TileMode:=tbVertical; Tile; end;

procedure TMainForm.MainMenu_Fenster_Ueberlappen_OnClick(Sender: TObject);
begin Cascade; end;

procedure TMainForm.MainMenu_Fenster_SymboleAnordnen_OnClick(Sender: TObject);
begin ArrangeIcons; end;

procedure TMainForm.MainMenu_Tools_OnClick(Sender: TObject);
var MTOC_Str1: string;
begin
  If FileExists(ActiveMDIChild.Caption) then MTOC_Str1:=ActiveMDIChild.Caption else MTOC_Str1:='';
  ExecuteFile((Sender as TMenuItem).Hint,MTOC_Str1);
end;

procedure TMainForm.MainMenu_Hilfe_Hilfethemen_OnClick(Sender: TObject);
var MHHOC_Str1: string;
begin
  MHHOC_Str1:='Readme.txt'; If FileExists(MHHOC_Str1) then MHHOC_Str1:=ExpandFileName(MHHOC_Str1) else
  If FileExists(ExtractFilePath(ParamStr(0))+MHHOC_Str1) then MHHOC_Str1:=ExtractFilePath(ParamStr(0))+MHHOC_Str1 else
  If FileExists(ExtractFilePath(ParamStr(0))+'Doc\'+MHHOC_Str1) then MHHOC_Str1:=ExtractFilePath(ParamStr(0))+'Doc\'+MHHOC_Str1;
  OpenTextFile(MHHOC_Str1);
end;

procedure TMainForm.MainMenu_Hilfe_Infos_OnClick(Sender: TObject);
begin With TInfosForm.Create(Self) do Try ShowModal; Finally Free; end; end;

{-------------------------------------------------------------------------------
Toolbars
-------------------------------------------------------------------------------}

procedure TMainForm.Button_Speichern_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Datei_Speichern_OnClick(Sender); end;

procedure TMainForm.Button_Drucken_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Datei_Drucken_OnClick(Sender); end;

procedure TMainForm.Button_Rueckgaengig_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Bearbeiten_Rueckgaengig_OnClick(Sender); end;

procedure TMainForm.Button_Wiederherstellen_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Bearbeiten_Wiederherstellen_OnClick(Sender); end;

procedure TMainForm.Button_Ausschneiden_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Bearbeiten_Ausschneiden_OnClick(Sender); end;

procedure TMainForm.Button_Kopieren_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Bearbeiten_Kopieren_OnClick(Sender); end;

procedure TMainForm.Button_Einfuegen_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Bearbeiten_Einfuegen_OnClick(Sender); end;

procedure TMainForm.Button_Loeschen_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Bearbeiten_Loeschen_OnClick(Sender); end;

procedure TMainForm.Button_Grossbuchstaben_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Markierung_InGrobuchstabenUmwandeln_OnClick(Sender); end;

procedure TMainForm.Button_Kleinbuchstaben_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Markierung_InKleinbuchstabenUmwandeln_OnClick(Sender); end;

procedure TMainForm.Button_NichtsMarkieren_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Markierung_NichtsMarkieren_OnClick(Sender); end;

procedure TMainForm.Button_AllesMarkieren_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Markierung_AllesMarkieren_OnClick(Sender); end;

procedure TMainForm.Button_Suchen_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Suchen_Suchen_OnClick(Sender); end;

procedure TMainForm.Button_Weitersuchen_OnClick(Sender: TObject);
begin TMainChildForm(ActiveMDIChild).MainMenu_Suchen_Weitersuchen_OnClick(Sender); end;

{-------------------------------------------------------------------------------
Public-Deklarationen
-------------------------------------------------------------------------------}

function TMainForm.AndereDSM32InstanzAktivieren: boolean;
var FindTitle: pchar; Sem: THandle; Wind: HWnd;
begin
  Sem:=CreateSemaphore(nil,0,1,'DSM32 V5 - Semaphore'); Result:=(Sem<>0)and(GetLastError=ERROR_ALREADY_EXISTS);
  If Result then begin CloseHandle(Sem); FindTitle:=PChar(Application.Title); Application.Title:='DSM32 V5 - Wait...'; Wind:=FindWindow(nil,FindTitle);
    If Wind<>0 then begin ShowWindow(Wind,SW_RESTORE); SetForegroundWindow(Wind); end; end;
end;

procedure TMainForm.OpenTextFile(TextFileStr: string);
begin
  If not FileExists(TextFileStr) then begin
    MessageBox(0,PChar('Die angegebene Datei "'+TextFileStr+'" konnte nicht gefunden werden.'),'Fehler:',MB_IconStop+MB_Ok+MB_SetForeground+MB_ApplModal);
    Exit;
  end;
  With TMainChildForm.Create(Self) do Try
    Screen.Cursor:=crHourGlass; StatusBar.SimpleText:='Datei wird eingelesen...';
    RichEdit.Lines.LoadFromFile(TextFileStr); RichEdit.Modified:=false;
    SetEnDisAbledState(11); Caption:=TextFileStr; inc(ChildNr); Tag:=ChildNr;
    With TTabSheet.Create(MainForm.PageCtrl) do begin PageControl:=MainForm.PageCtrl;
      Name:='Tab'+IntToStr(ChildNr); Caption:=ExtractFileName(TextFileStr); Tag:=ChildNr;
      MainForm.PageCtrl.ActivePage:=MainForm.PageCtrl.Pages[TabIndex]; end;
    If IfReadOnlyThenNurLesenZulassen then If FileIsReadOnly(TextFileStr) then MainMenu_Bearbeiten_NurLesenZulassen_OnClick(nil);
  Finally StatusBar.SimplePanel:=false; Screen.Cursor:=crDefault; end;
end;

procedure TMainForm.AddItemToToolsMenu(CaptionStr, HintStr: string);
var AITTM_MenuItem: TMenuItem;
begin
  If not MainMenu_Tools.Visible then MainMenu_Tools.Visible:=true;
  AITTM_MenuItem:=TMenuItem.Create(MainMenu_Tools); AITTM_MenuItem.Caption:=CaptionStr; AITTM_MenuItem.Hint:=HintStr;
  AITTM_MenuItem.OnClick:=MainMenu_Tools_OnClick; MainMenu_Tools.Add(AITTM_MenuItem);  
end;

procedure TMainForm.PageCtrlChange(Sender: TObject);
Var Coke: integer;
begin
  For Coke:=0 to MainForm.ComponentCount-1 do If mainform.components[coke] is TForm then
    If Tcontrol(mainform.components[coke]).tag = PageCtrl.ActivePage.Tag then (MainForm.components[coke] as Tform).bringtofront;
end;

END.
